#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-
import sys
import time
import RTC
import OpenRTM_aist
import urllib2
import json
import base64
import subprocess
import os
RtcNonMonoSpeech_spec = ["implementation_id", "RtcNonMonoSpeech",
                  "type_name",         "RtcNonMonoSpeech",
                  "description",       "string",
                  "version",           "1.0",
                  "vendor",            "OKADA,H",
                  "category",          "speech",
                  "activity_type",     "DataFlowComponent",
                  "max_instance",      "10",
                  "language",          "Python",
                  "lang_type",         "script",
                  ""]


class DataListener(OpenRTM_aist.ConnectorDataListenerT):
  def __init__(self, obj):
    self._obj = obj

  def __call__(self, info, cdrdata):
    data = OpenRTM_aist.ConnectorDataListenerT.__call__(self, info, cdrdata, RTC.TimedString(RTC.Time(0,0),""))
    self._obj.onData(data)

class RtcNonMonoSpeech(OpenRTM_aist.DataFlowComponentBase):
  def __init__(self, manager):
    OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

  def onInitialize(self):
    inport = OpenRTM_aist.InPort("in", RTC.TimedString(RTC.Time(0,0),""))
    inport.addConnectorDataListener(OpenRTM_aist.ConnectorDataListenerType.ON_RECEIVED,DataListener(self))
    self.addInPort("in", inport)
    return RTC.RTC_OK

  def onData(self, data):
    text = data.data
    da = req( text.decode('sjis').encode('utf-8') )
    os.system('cmdmp3.exe out.wav')

# service URL
tts_url ='http://rospeex.ucri.jgn-x.jp/nauth_json/jsServices/VoiceTraSS'

def req( word ):
	tts_command = { 'method':'speak', 'params':['1.1', {'language':'ja','text':word,'voiceType':"*",'audioType':"audio/x-wav"}]}
	obj_command = json.dumps(tts_command) 
	req = urllib2.Request(tts_url, obj_command)
	received = urllib2.urlopen(req).read()    # get data from server
	obj_received = json.loads(received)
	tmp = obj_received['result']['audio'] # extract result->audio
	speech = base64.decodestring(tmp.encode('utf-8'))
	f = open ("out.wav",'wb')
	f.write(speech)
	f.close
	return speech


def RtcNonMonoSpeechInit(manager):
  profile = OpenRTM_aist.Properties(defaults_str=RtcNonMonoSpeech_spec)
  manager.registerFactory(profile,
                          RtcNonMonoSpeech,
                          OpenRTM_aist.Delete)


def MyModuleInit(manager):
  RtcNonMonoSpeechInit(manager)

  # Create a component
  comp = manager.createComponent("RtcNonMonoSpeech")

def main():
  # Initialize manager
  mgr = OpenRTM_aist.Manager.init(sys.argv)

  # Set module initialization proceduer
  # This procedure will be invoked in activateManager() function.
  mgr.setModuleInitProc(MyModuleInit)

  # Activate manager and register to naming service
  mgr.activateManager()

  # run the manager in blocking mode
  # runManager(False) is the default
  mgr.runManager()

  # If you want to run the manager in non-blocking mode, do like this
  # mgr.runManager(True)

if __name__ == "__main__":
  main()
